//(c) 2016 Dmitry Grinberg   http://dmitry.gr   me@dmitry.gr   see LICENSE.txt

#ifndef _KLN_H_
#define _KLN_H_

#include "wincompat.h"


bool klnDecrypt(uint8_t *dst, uint32_t *dstSzP, const uint8_t *src, uint32_t srcSz);	//*dstSzP on input is mas size we can produce produce!
bool klnVerifyChecksumsAndShowInfo(const uint8_t *data, uint32_t sz);

PACKED_START
struct KlnAllBlockChecksums {
	struct BlockChecksum {
		uint16_t var48;
		uint16_t var38;
	} sum[16];
} PACKED_MID ; PACKED_END

PACKED_START
struct KlnDateFmt {
	uint8_t mn, da, yr;	//year is 1988 - 2087
} PACKED_MID ; PACKED_END

PACKED_START
struct KlnDecryptedUpdateHeader {
	struct KlnAllBlockChecksums cksums;	//0x00
	uint16_t chipMapWord;				//0x40
	uint32_t key;						//0x42
	uint32_t magix;						//0x46
	uint8_t reserved_all_FFs[12];		//0x4A
} PACKED_MID ; PACKED_END				//0x56

PACKED_START
struct KlnDecryptedUpdateData {
	uint8_t reserved1[2];				//0x066
	char friendlyName[30];				//0x068
	uint8_t reserved2[886];				//0x076
	struct KlnDateFmt startdate;		//0x3EC
	struct KlnDateFmt expiredate;		//0x3EF
	struct KlnDateFmt somedate2;		//0x3F2
	uint8_t reserved4[11];				//0x3F5
	uint8_t compressedName[12];			//0x400
} PACKED_MID ; PACKED_END	


#endif

